/*
 * $Id: cccpp_pr.prg,v 1.1 1999/11/09 01:37:23 vszel Exp $
 */

//*******************************************************************
// cccpp_pr.prg: Process input
// 1999, Csiszr Levente
//*******************************************************************


//*******************************************************************
#include "debug.ch"
#include "ctoken.ch"

//*******************************************************************
#include "objgen.ch"

//*******************************************************************
#include "lreader.och"
#include "nparser.och"
#include "lparser.och"
#include "incl.och"
#include "hparser.och"
#include "mcontrol.och"
#include "parser.och"
#include "token.och"


//*******************************************************************
static function cccpp_printErrorStream(errorStream)
   if (!empty(errorStream))
      evalErrorStream(errorStream,{|x| outerr(x,newline())})
      asize(errorStream,0)
      return .t.
   endif
return .f.

//*******************************************************************
function cccpp_processReader(reader,outFid,;
                             incArray,maxInclDeep,;
                             defDict,xtrdict,errorStream,;
                             trPrsAlg)
// Feldolgoz egy filt, Egyenlre nem vgez hiba ellezrzst.

local lrd,npr,lpr,hpr,mcr,t,inclObj
local line,emptyLines,hiba
                          
   hiba:=.f.

   if (cccpp_printErrorStream(errorStream))
      hiba:=.t.
      return hiba
   endif

   // fr:=C.FREADER:onew(errorStream)
   // FREADER.fr:open("",inputFileName)
   lrd:=C.LREADER:onew(CTK_BOS,CTK_EOS,READER.reader:name,errorStream)
   LREADER.lrd:pushReader(reader)
   npr:=C.NPARSER:onew(lrd,READER.lrd:name,errorStream)
   lpr:=C.LPARSER:onew(npr,READER.npr:name,errorStream)
   inclObj:=C.INCL:onew(lrd,incArray,maxInclDeep)
   // inclObj:=C.INCL:onew(lrd,{dirFName(filename)})
   hpr:=C.HPARSER:onew(lpr,READER.lpr:name,;
                       defDict/*C.DEFDICT:onew()*/,xtrDict/*C.XTRDICT:onew()*/,;
                       inclObj,errorStream)
   mcr:=C.MCONTROL:onew(hpr,READER.hpr:name,;
                        HPARSER.hpr:defDict,HPARSER.hpr:xtrdict,;
                        errorStream,trPrsAlg)

   line:=""
   emptyLines:=""
   while(nil!=(t:=PARSER.mcr:read()))
      // outstd(TOKEN.t:getStr())
      // wStr:=TOKEN.t:getStr()
      // fwrite(fid,wStr,len(wStr))
      if (outFid!=nil)
         // Itt kell kozmetikzni a sorokat.
         /*
            1. res sorok hosszt nullra redukljuk.
            2. #line eltti res sorokat trljk. (BOS)
            3. EOS eltti res sorokat trljk.
         */
         if (TOKEN.t:id==TKID_UJSOR)
            // j sor. Az res sorokat az emptyLines-ban troljuk.
            if (!empty(line))
               fwrite(outFid,emptyLines)
               emptyLines:=""
               fwrite(outFid,line)
               line:=""
               fwrite(outFid,TOKEN.t:getStr())
            else
               emptyLines+=TOKEN.t:getStr()
               line:=""
            endif
         elseif (TOKEN.t:id==TKID_EOS .or.;
                 TOKEN.t:id==TKID_BOS)
            // Az EOS s a BOS eltti res sorokat trlni kell.
            // Mj.: Itt nincs kezelve az az esetet, amikor nincs 
            //      sorvgjel az include fil vgn.
            if (!empty(line))
               fwrite(outFid,emptyLines)
               emptyLines:=""
               fwrite(outFid,line)
               line:=""
               fwrite(outFid,TOKEN.t:getStr())
            else
               emptyLines:=""
               line:=""
               // Ha az EOS/BOS rni akar valamit, azt kitesszk.
               fwrite(outFid,TOKEN.t:getStr())
            endif
         else
            line+=TOKEN.t:getStr()
         endif   
      endif
      // Itt ki kell olvasni a hibkat.
      if (cccpp_printErrorStream(errorStream))
         hiba:=.t.
      endif
   end while
   // Nem kell az utols sorra figyelni, mert mindig jn egy EOS.
   
   // Elvgezzk a szksges ellenrzseket a fil vgn. 
   // (Lezratlan #if, etc)
   HPARSER.hpr:chkEndOfFile()
   if (cccpp_printErrorStream(errorStream))
      hiba:=.t.
   endif
   
return hiba

//*******************************************************************

