//
// $Id: lreader.cls,v 1.1 1999/11/09 01:37:24 vszel Exp $
//

//*******************************************************************
// lreader.cls: Lnc reader.
// 1999, Csiszr Levente

// Ez a reader readerek stackjn keresztl olvas, gy, hogy olvas a 
// legfelsbl, ha az elrte az EOF-ot, akkor kld egy EOS (End Of 
// Stream)-et, eldobja a stack tetejn lev reader-t, s folytatja 
// az olvasst a stack tetejn maradt reader-el.
// Amikor j stream-et kezd, akkor kld egy BOS (Begin Of Stream)
// elemet.
// Az EOS s a BOF rtke paramterezhet, st el is hagyhatak.

// Mj.: A stackbl trlt reader-ekre kiadja a destruct()-ot.
//      Egy lreader destruct-ja az sszes a stack-jben lev reader
//      destructjt jelenti.
// Mj2.: Az errorStream-et nem lltja, arrl, hogy a hibkat
//       megkapjuk neknk kell gondoskodni.

// A neve mindig a stack legfels eleme.


class LREADER CREADER

   attrib readerStack  // A stack, amiben a reader-ek vannak.
                       // Egy elem {reader,needBOS} alak.
                       // A needBOS .t., ha kell BOS-t kldeni
                       // .f., ha nem.

   attrib BOSItem      // A BOS elem. Brmilyen objektum vagy 
                       // rtk lehet (karakter is.)
                       // Ha nil, akkor nem kld ilyet.
      
   attrib EOSItem      // Az EOS elem. Brmilyen objektum vagy 
                       // rtk lehet (karakter is.)
                       // Ha nil, akkor nem kld ilyet.
   rmethod readItem()
   // Olvas egy elemet. 
   // Ret: Az elem, ha OK, nil, ha vge van a streamnek, vagy ha
   //      hiba volt.
   
   nmethod pushReader(aReader)
   // Az itt megadott readert beteszi a stack-be. A legkzelebbi
   // olvass ebbl fog olvasni.
   
   nmethod topReader()
   // Megadja a stack tetejn lev readert. Ha nincs ret nil
   
   nmethod popReader()
   // Visszaadja a stack tetejn lev readert, s a stack-rl trli.
   // Nem adja ki r a destruct()-ot.
   
   nmethod dropReader()
   // A stackrl trli a tetejn lev readert.
   // Kiadja r a destruct()-ot.
   
   nmethod isEmpty()
   // Igaz, ha a stack res, egybknt hamis.
   
   nmethod getBOSItem()
   // Ad egy BOS itemet.
   
   nmethod getEOSItem()
   // Ad egy EOS itemet.
   
   rmethod getFile()
   rmethod getLine()
   rmethod getPos()

   rmethod oinit(BOSItem,EOSItem,name,errorStream)
   // Inicializlja az objektumot.
   
metaclass

   rmethod onew(BOSItem,EOSItem,name,errorStream)



